// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "display/animation/Animation.hpp"

namespace Dawn {
  class AnimationController : public SceneItemComponent {
    private:
      std::vector<Animation*> animations;

    public:
      AnimationController(SceneItem *item);

      /**
       * Add an animation to this controller.
       * 
       * @param animation Pointer to the animation to add.
       */
      void addAnimation(Animation *animation);

      void onStart() override;
  };
}