// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "scene/components/physics/2d/CharacterController2D.hpp"
#include "scene/components/entity/EntityHealth.hpp"
#include "scene/components/entity/EntityAttackBase.hpp"

namespace Dawn {
  class EntityMove : public SceneItemComponent {
    protected:
      CharacterController2D *characterController = nullptr;
      EntityHealth *entityHealth = nullptr;
      
    public:
      // @optional
      float_t moveSpeed = 30.0f;
      // @optional
      glm::vec2 direction = glm::vec2(0, 0);

      EntityMove(SceneItem* item);
      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}