// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/XmlParser.hpp"

namespace Dawn {
  struct VNPositionEvent {
    std::string x = "";
    std::string y = "";
    std::string z = "";
    std::string item = "";
  };

  class VNPositionEventParser : public XmlParser<struct VNPositionEvent> {
    protected:
      std::vector<std::string> getRequiredAttributes() override;
      std::map<std::string, std::string> getOptionalAttributes() override;
      int32_t onParse(
        Xml *node,
        std::map<std::string, std::string> values,
        struct VNPositionEvent *out,
        std::string *error
      ) override;
  };
}